/*
 * TCS Dependency Map Renderer
 *
 * Copyright (c) 2005 TopCoder, Inc. All rights reserved.
 *
 * Author: TCSDeveloper
 */

using System;
using System.IO;
using NUnit.Framework;
using System.Drawing;
using System.Drawing.Drawing2D;

namespace TopCoder.Rules.DependencyMap.View
{   
    /// <summary>
    /// Failure test fixture for ShapeFactory.
    /// </summary>
    [TestFixture]
    public class ShapeFactoryTests
    {   
        private GraphicsPath goodShape = new GraphicsPath();
	
        /// <summary>
        /// Invalid input to set.
        /// </summary>
        [Test]
        [ExpectedException(typeof(ArgumentOutOfRangeException))]
        public void testSet_Inv() 
        {
            new ShapeFactory()[-1] =  goodShape;
        }

        /// <summary>
        /// Invalid input to set.
        /// </summary>
        [Test]
        [ExpectedException(typeof(ArgumentOutOfRangeException))]
        public void testSet_Inv2() 
        {
            new ShapeFactory()[int.MinValue] =  goodShape;
        }

        /// <summary>
        /// Invalid input to set.
        /// </summary>
        [Test]
        [ExpectedException(typeof(ArgumentOutOfRangeException))]
        public void testSet_Inv3() 
        {
            new ShapeFactory()[0] = goodShape;
        }
	
        /// <summary>
        /// Invalid input to set.
        /// </summary>
        [Test]
        [ExpectedException(typeof(ArgumentNullException))]
        public void testSet_Null() 
        {
            new ShapeFactory()[1] =  null;
        }

        /// <summary>
        /// Invalid input to Get.
        /// </summary>
        [Test]
        [ExpectedException(typeof(ArgumentOutOfRangeException))]
        public void testGet_Inv() 
        {
            object test = new ShapeFactory()[-1];
        }
	
        /// <summary>
        /// Invalid input to Get.
        /// </summary>
        [Test]
        [ExpectedException(typeof(ArgumentOutOfRangeException))]
        public void testGet_Inv2() 
        {
            object test = new ShapeFactory()[int.MinValue];
        }
	
        /// <summary>
        /// Invalid input to Get.
        /// </summary>
        [Test]
        [ExpectedException(typeof(ArgumentOutOfRangeException))]
        public void testGet_Inv3() 
        {
            object test = new ShapeFactory()[0];
        }
	
        /// <summary>
        /// Invalid input to Remove.
        /// </summary>
        [Test]
        [ExpectedException(typeof(ArgumentOutOfRangeException))]
        public void testRemove_Inv() 
        {
            new ShapeFactory().RemoveShape(-1);
        }
	
        /// <summary>
        /// Invalid input to Get.
        /// </summary>
        [Test]
        [ExpectedException(typeof(ArgumentOutOfRangeException))]
        public void testRemove_Inv2() 
        {
            new ShapeFactory().RemoveShape(int.MinValue);
        }
	
        /// <summary>
        /// Invalid input to Remove.
        /// </summary>
        [Test]
        [ExpectedException(typeof(ArgumentOutOfRangeException))]
        public void testRemove_Inv3() 
        {
            new ShapeFactory().RemoveShape(0);
        }
	
        /// <summary>
        /// Invalid input to Remove.
        /// </summary>
        [Test]
        [ExpectedException(typeof(ArgumentException))]
        public void testRemove_InvPD() 
        {
            new ShapeFactory().RemoveShape(ShapeFactory.RelationshipArrow);
        }
	
        /// <summary>
        /// Invalid input to Remove.
        /// </summary>
        [Test]
        [ExpectedException(typeof(ArgumentException))]
        public void testRemove_InvPD2() 
        {
            new ShapeFactory().RemoveShape(ShapeFactory.SeenElement);
        }
	
        /// <summary>
        /// Invalid input to Remove.
        /// </summary>
        [Test]
        [ExpectedException(typeof(ArgumentException))]
        public void testRemove_InvPD3() 
        {
            new ShapeFactory().RemoveShape(ShapeFactory.UnseenElement);
        }
    }
}
